Index: pjproject/trunk/pjsip-apps/build/get-footprint.py
===================================================================
--- pjproject/trunk/pjsip-apps/build/get-footprint.py	(revision 590)
+++ pjproject/trunk/pjsip-apps/build/get-footprint.py	(revision 591)
@@ -34,5 +34,5 @@
 
     ['HAS_PJLIB', 		'PJLIB (pool, data structures, hash tables, ioqueue, socket, timer heap, etc.)'],
-    ['', 			'Subtotal: Minimum PJLIB application size (linked with OS libraries)'],
+    ['', 			'Subtotal: Minimal PJLIB application size'],
 
     # PJLIB-UTIL
@@ -43,5 +43,7 @@
 
     # PJSIP
-    ['HAS_PJSIP_CORE',		'PJSIP Core (endpoint, transport manager, parser, message elements, module mgmt, etc.)'],
+    ['HAS_PJSIP_CORE_MSG_ELEM',	'PJSIP Core - Messaging Elements and Parsing (message, headers, SIP URI, TEL URI/RFC 3966, etc.)'],
+    ['HAS_PJSIP_CORE',		'PJSIP Core - Endpoint (transport management, module management, event distribution, etc.)'],
+    ['HAS_PJSIP_CORE_MSG_UTIL',	'PJSIP Core - Stateless operations, server resolution and fail-over'],
     ['HAS_PJSIP_UDP_TRANSPORT',	'PJSIP UDP transport'],
     ['',			'Subtotal: A very minimum SIP application (parsing, UDP transport+STUN, no transaction)'],
@@ -50,6 +52,7 @@
     ['HAS_PJSIP_INFO',		'PJSIP INFO support (RFC 2976) (no special treatment, thus the zero size)'],
     ['HAS_PJSIP_TRANSACTION',	'PJSIP transaction and stateful API'],
+    ['HAS_PJSIP_AUTH_CLIENT',	'PJSIP digest authentication client'],
     ['HAS_PJSIP_UA_LAYER',	'PJSIP User agent layer and base dialog and usage management (draft-ietf-sipping-dialogusage-01)'],
-    ['HAS_PJMEDIA_SDP',		'PJMEDIA SDP API (RFC 2327), needed by SDP negotiator'],
+    ['HAS_PJMEDIA_SDP',		'PJMEDIA SDP Parsing and API (RFC 2327), needed by SDP negotiator'],
     ['HAS_PJMEDIA_SDP_NEGOTIATOR','PJMEDIA SDP negotiator (RFC 3264), needed by INVITE session'],
     ['HAS_PJSIP_INV_SESSION',	'PJSIP INVITE session API'],
@@ -75,5 +78,5 @@
     ['HAS_PJMEDIA_PLC',		'PJMEDIA Packet Lost Concealment implementation (needed by G.711, GSM, and sound device port)'],
     ['HAS_PJMEDIA_SND_PORT',	'PJMEDIA sound device media port'],
-    ['HAS_PJMEDIA_RESAMPLE',	'PJMEDIA high quality resampling implementation (can be fine tuned with PJMEDIA_HAS_LARGE_FILTER and PJMEDIA_HAS_SMALL_FILTER)'],
+    ['HAS_PJMEDIA_RESAMPLE',	'PJMEDIA resampling algorithm (large filter disabled)'],
     ['HAS_PJMEDIA_G711_CODEC',	'PJMEDIA G.711 codec (PCMA/PCMU, including PLC) (may have already been linked by other module)'],
     ['HAS_PJMEDIA_CONFERENCE',	'PJMEDIA conference bridge (needs resampling and silence detector)'],
Index: pjproject/trunk/pjsip-apps/src/samples/footprint.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/samples/footprint.c	(revision 590)
+++ pjproject/trunk/pjsip-apps/src/samples/footprint.c	(revision 591)
@@ -44,5 +44,8 @@
 #define HAS_PJLIB_SCANNER
 
+#define HAS_PJSIP_CORE_MSG_ELEM
 #define HAS_PJSIP_CORE
+#define HAS_PJSIP_CORE_MSG_UTIL
+
 #define HAS_PJSIP_UDP_TRANSPORT
 #define HAS_PJSIP_TCP_TRANSPORT
@@ -51,4 +54,5 @@
 #define HAS_PJMEDIA_SDP
 #define HAS_PJMEDIA_SDP_NEGOTIATOR
+#define HAS_PJSIP_AUTH_CLIENT
 #define HAS_PJSIP_INV_SESSION
 #define HAS_PJSIP_REGC
@@ -149,8 +153,56 @@
     pj_scan_restore_state(NULL, NULL);
 #endif
-    
+
+#ifdef HAS_PJSIP_CORE_MSG_ELEM
+    /* Parameter container */
+    pjsip_param_find(NULL, NULL);
+    pjsip_param_print_on(NULL, NULL, 0, NULL, NULL, 0);
+
+    /* SIP URI */
+    pjsip_sip_uri_create(NULL, 0);
+    pjsip_name_addr_create(NULL);
+
+    /* TEL URI */
+    pjsip_tel_uri_create(NULL);
+
+    /* Message and headers */
+    pjsip_msg_create(NULL, PJSIP_REQUEST_MSG);
+    pjsip_msg_print(NULL, NULL, 0);
+    pjsip_accept_hdr_create(NULL);
+    pjsip_allow_hdr_create(NULL);
+    pjsip_cid_hdr_create(NULL);
+    pjsip_clen_hdr_create(NULL);
+    pjsip_cseq_hdr_create(NULL);
+    pjsip_contact_hdr_create(NULL);
+    pjsip_ctype_hdr_create(NULL);
+    pjsip_expires_hdr_create(NULL, 0);
+    pjsip_from_hdr_create(NULL);
+    pjsip_max_fwd_hdr_create(NULL, 0);
+    pjsip_min_expires_hdr_create(NULL, 0);
+    pjsip_rr_hdr_create(NULL);
+    pjsip_require_hdr_create(NULL);
+    pjsip_retry_after_hdr_create(NULL, 0);
+    pjsip_supported_hdr_create(NULL);
+    pjsip_unsupported_hdr_create(NULL);
+    pjsip_via_hdr_create(NULL);
+    pjsip_warning_hdr_create(NULL, 0, NULL, NULL);
+
+    pjsip_parse_uri(NULL, NULL, 0, 0);
+    pjsip_parse_msg(NULL, NULL, 0, NULL);
+    pjsip_parse_rdata(NULL, 0, NULL);
+    pjsip_find_msg(NULL, 0, 0, NULL);
+#endif
+
 #ifdef HAS_PJSIP_CORE
     pjsip_endpt_create(NULL, NULL, NULL);
 
+    pjsip_tpmgr_create(NULL, NULL, NULL, NULL, NULL);
+    pjsip_tpmgr_destroy(NULL);
+    pjsip_transport_send(NULL, NULL, NULL, 0, NULL, NULL);
+
+
+#endif
+
+#ifdef HAS_PJSIP_CORE_MSG_UTIL
     pjsip_endpt_create_request(NULL, NULL, NULL, NULL, NULL, NULL, NULL,
 			       -1, NULL, NULL);
@@ -223,4 +275,12 @@
     pjsip_dlg_send_response(NULL, NULL, NULL);
     pjsip_dlg_respond(NULL, NULL, -1, NULL, NULL, NULL);
+#endif
+
+#ifdef HAS_PJSIP_AUTH_CLIENT
+    pjsip_auth_clt_init(NULL, NULL, NULL, 0);
+    pjsip_auth_clt_clone(NULL, NULL, NULL);
+    pjsip_auth_clt_set_credentials(NULL, 0, NULL);
+    pjsip_auth_clt_init_req(NULL, NULL);
+    pjsip_auth_clt_reinit_req(NULL, NULL, NULL, NULL);
 #endif
 